=== debian/changelog ===
libtraceevent (1:1.1.0-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
    - Removed from kernel builds so last kernel update did not update
      libtraceevent in buster-backports.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 26 Nov 2020 18:43:35 +0000

libtraceevent (1:1.1.0-2) unstable; urgency=medium

  * Source only upload.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 01 Nov 2020 17:52:58 +0000

libtraceevent (1:1.1.0-1) unstable; urgency=medium

  * Create new libtraceevent package from upstream repo. (Closes: #971976)
    - libtraceevent package to be removed from kernel builds.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 30 Oct 2020 12:52:36 +0000
