=== debian/changelog ===
libtraceevent (1:1.1.2-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 05 Jul 2023 14:59:38 -0700

libtraceevent (1:1.1.2-1) unstable; urgency=medium

  * New upstream version 1.1.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 15 Feb 2021 20:07:08 +0000

libtraceevent (1:1.1.1-2) unstable; urgency=medium

  * Fix FTCBFS: Export CROSS_COMPILE. (Closes: #973840)
    - Thanks to Helmut Grohne.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 24 Jan 2021 22:04:21 +0000

libtraceevent (1:1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1
    - Update copyright.
    - Removed patches applied upstream.
    - Update symbols.
    - Ignore tests depending on DESTDIR.
  * Enable verbose builds unless 'terse' DEB_BUILD_OPTIONS is set.
  * Update Standards-Version to 4.5.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 15 Jan 2021 21:05:31 +0000
