=== debian/control ===
--- 
+++ 
@@ -1,8 +1,13 @@
 Source: libtraceevent
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), pkg-config, asciidoc, xmlto, source-highlight
-Standards-Version: 4.5.0
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Build-Depends: asciidoc,
+               debhelper-compat (= 12),
+               pkg-config,
+               source-highlight,
+               xmlto
+Standards-Version: 4.5.1
 Section: libs
 Vcs-Browser: https://salsa.debian.org/sudip/libtraceevent
 Vcs-Git: https://salsa.debian.org/sudip/libtraceevent.git
@@ -11,7 +16,9 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends: libtraceevent1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libtraceevent1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Linux kernel trace event library (development files)
  The libtraceevent library provides APIs to access kernel tracepoint events,
  located in the tracefs file system under the events directory.
@@ -21,7 +28,7 @@
 Package: libtraceevent1
 Architecture: linux-any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Linux kernel trace event library (shared library)
  The libtraceevent library provides APIs to access kernel tracepoint events,
  located in the tracefs file system under the events directory.
@@ -30,7 +37,9 @@
 
 Package: libtraceevent1-plugin
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libtraceevent1 (= ${binary:Version})
+Depends: libtraceevent1 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Multi-Arch: same
 Description: Linux kernel trace event library (plugins)
  The libtraceevent library provides APIs to access kernel tracepoint events,
