=== debian/changelog ===
libtraceevent (1:1.3.3-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream version 1.3.3
    - Update symbols.
  * Update Standards-Version to 4.6.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 28 Aug 2021 23:44:25 +0100

libtraceevent (1:1.3.0-1) experimental; urgency=medium

  * New upstream version 1.3.0
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 23 May 2021 16:59:07 +0100

libtraceevent (1:1.2.1-1) experimental; urgency=medium

  * New upstream version 1.2.1
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 24 Apr 2021 00:28:15 +0100

libtraceevent (1:1.1.3-1) experimental; urgency=medium

  * New upstream version 1.1.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 02 Apr 2021 22:58:49 +0100
