=== debian/rules ===
--- 
+++ 
@@ -20,8 +20,3 @@
 	dh_auto_install -- doc-install $(build_flags)
 
 override_dh_auto_test:
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
