## libtraceevent 1.6.2

=== debian/changelog ===
libtraceevent (1:1.6.2-1) unstable; urgency=medium

  * New upstream version 1.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 11 Aug 2022 16:25:03 +0100

libtraceevent (1:1.6.1-1) unstable; urgency=medium

  * New upstream version 1.6.1
  * Update Standards-Version to 4.6.1.0
  * Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 28 Jun 2022 21:33:23 +0100

libtraceevent (1:1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0
    - Update symbols.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 05 Jun 2022 21:45:30 +0100

libtraceevent (1:1.5.3-1) unstable; urgency=medium

  * New upstream version 1.5.3
  * Disable parallel builds. (Closes: #1009042)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 22 Apr 2022 11:33:06 +0100

libtraceevent (1:1.5.1-1) unstable; urgency=medium

  * New upstream version 1.5.1
    - Update symbols file.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 27 Feb 2022 00:35:26 +0000
